Create StatementDefinition - m3ter Documentation
Create StatementDefinition
cURL
curl --request POST \
--url https://api.m3ter.com/organizations/{orgId}/statementdefinitions \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"version": 123,
"name": "<string>",
"includePricePerUnit": true,
"dimensions": [
{
"name": "<string>",
"filter": [
"<string>"
],
"meterId": "<string>",
"attributes": [
"<string>"
]
}
],
"measures": [
{
"meterId": "<string>",
"name": "<string>",
"aggregations": []
}
],
"generateSlimStatements": true
}
'
Python
import requests
url = "https://api.m3ter.com/organizations/{orgId}/statementdefinitions"
payload = {
"version": 123,
"name": "<string>",
"includePricePerUnit": True,
"dimensions": [
{
"name": "<string>",
"filter": ["<string>"],
"meterId": "<string>",
"attributes": ["<string>"]
}
],
"measures": [
{
"meterId": "<string>",
"name": "<string>",
"aggregations": []
}
],
"generateSlimStatements": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)
JavaScript (Fetch)
const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
version: 123,
name: '<string>',
includePricePerUnit: true,
dimensions: [
{
name: '<string>',
filter: ['<string>'],
meterId: '<string>',
attributes: ['<string>']
}
],
measures: [{meterId: '<string>', name: '<string>', aggregations: []}],
generateSlimStatements: true
})
};
fetch('https://api.m3ter.com/organizations/{orgId}/statementdefinitions', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
PHP
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/statementdefinitions",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'version' => 123,
'name' => '<string>',
'includePricePerUnit' => true,
'dimensions' => [
[
'name' => '<string>',
'filter' => [
'<string>'
],
'meterId' => '<string>',
'attributes' => [
'<string>'
]
]
],
'measures' => [
[
'meterId' => '<string>',
'name' => '<string>',
'aggregations' => []
]
],
'generateSlimStatements' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}
Go
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.m3ter.com/organizations/{orgId}/statementdefinitions"
payload := strings.NewReader("{\n \"version\": 123,\n \"name\": \"<string>\",\n \"includePricePerUnit\": true,\n \"dimensions\": [\n {\n \"name\": \"<string>\",\n \"filter\": [\n \"<string>\"\n ],\n \"meterId\": \"<string>\",\n \"attributes\": [\n \"<string>\"\n ]\n }\n ],\n \"measures\": [\n {\n \"meterId\": \"<string>\",\n \"name\": \"<string>\",\n \"aggregations\": []\n }\n ],\n \"generateSlimStatements\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
Response Format
{
"id": "<string>",
"version": 123,
"name": "<string>",
"includePricePerUnit": true,
"dimensions": [
{
"name": "<string>",
"filter": [
"<string>"
],
"meterId": "<string>",
"attributes": [
"<string>"
]
}
],
"measures": [
{
"meterId": "<string>",
"name": "<string>",
"aggregations": []
}
],
"generateSlimStatements": true,
"dtCreated": "2023-11-07T05:31:56Z",
"dtLastModified": "2023-11-07T05:31:56Z",
"createdBy": "<string>",
"lastModifiedBy": "<string>"
}
Authorization
Authorization:
string, header, requiredm3ter supports machine to machine authentication using the
clientCredentialsOAuth2 flow.